=== modified file '.bzrignore'
--- .bzrignore	2011-01-25 03:30:11 +0000
+++ .bzrignore	2011-01-25 20:51:51 +0000
@@ -36,7 +36,7 @@
 m4/ltversion.m4
 m4/lt~obsolete.m4
 bin/scalestack
-scalestack/common/macros.h
+scalestack/kernel/macros.h
 scalestack/kernel/test/core
 scalestack/kernel/test/module
 scalestack/kernel/test/option

=== modified file 'Makefile.am'
--- Makefile.am	2011-01-25 06:25:30 +0000
+++ Makefile.am	2011-01-25 20:51:51 +0000
@@ -19,7 +19,6 @@
 ACLOCAL_AMFLAGS = -I m4
 LDADD = libscalestack.la
 AM_DEFAULT_SOURCE_EXT = .cc
-
 bin_PROGRAMS =
 check_PROGRAMS =
 noinst_PROGRAMS =
@@ -36,34 +35,32 @@
 	test_run.sh
 
 #
-# libscalestack
+# Definitions for libscalestack.
 #
 
 lib_LTLIBRARIES += libscalestack.la
 
 libscalestack_la_SOURCES = \
-	scalestack/common/exception.cc \
-	scalestack/common/notification.cc \
 	scalestack/kernel/core.cc \
+	scalestack/kernel/exception.cc \
 	scalestack/kernel/log_console.cc \
 	scalestack/kernel/module.cc \
 	scalestack/kernel/option.cc
 
 nobase_include_HEADERS += \
-	scalestack/common/delete_pointer.h \
-	scalestack/common/exception.h \
-	scalestack/common/notification.h \
 	scalestack/kernel/core.h \
+	scalestack/kernel/delete_pointer.h \
+	scalestack/kernel/exception.h \
 	scalestack/kernel/log.h \
 	scalestack/kernel/log_console.h \
 	scalestack/kernel/logger.h \
 	scalestack/kernel/module.h \
 	scalestack/kernel/option.h \
-	scalestack/kernel/service.h
+	scalestack/kernel/service.h \
+	scalestack/kernel/test.h
 
-noinst_HEADERS += scalestack/common/test.h
-nobase_nodist_include_HEADERS = scalestack/common/macros.h
-EXTRA_DIST += scalestack/common/macros.h.in
+nobase_nodist_include_HEADERS = scalestack/kernel/macros.h
+EXTRA_DIST += scalestack/kernel/macros.h.in
 
 libscalestack_la_CXXFLAGS = \
 	$(AM_CXXFLAGS) \
@@ -90,14 +87,22 @@
 	scalestack/kernel/test/config_file3
 
 #
-# Simple scalestack application
+# Simple scalestack application.
 #
 
 bin_PROGRAMS += bin/scalestack
 bin_scalestack_SOURCES = bin/scalestack.cc
 
+#
+# Include module configuration.
+#
+
 include config/pandora-plugin.am
 
+#
+# Tests, docs, and code coverage commands.
+#
+
 TESTS = $(check_PROGRAMS)
 
 TESTS_ENVIRONMENT = ${top_srcdir}/test_run.sh

=== modified file 'README'
--- README	2011-01-25 06:25:30 +0000
+++ README	2011-01-25 20:51:51 +0000
@@ -43,16 +43,16 @@
 Website: http://scalestack.org/
 Project: https://launchpad.net/scalestack
 IRC: #scalestack on irc.freenode.net
-Mailing list: https://launchpad.net/~scalestack-dev
+Mailing list: https://launchpad.net/~scalestack
 
 
 Contributing
 ------------
 
-All code is licensed under BSD, and all contributions will be taken
-under that license as well. Other licenses may be considered for
-self-contained modules. No copyright assignment is needed, you (or
-your employer) own your work. :)
+All code is licensed under the Apache 2.0 license, and all
+contributions will be taken under that license as well. Other licenses
+may be considered for self-contained modules. No copyright assignment
+is needed, you (or your employer) own your work. :)
 
 To get started fixing bugs, improving existing modules, or adding
 new modules, you'll want to register an account with Launchpad and
@@ -84,7 +84,7 @@
 your branch back up to Launchpad (which requires a Launchpad account).
 
 bzr add new_module
-bzr commit -m "Comment describing my changes"
+bzr commit -m "Comment describing my changes."
 bzr push lp:~johndoe/scalestack/my-changes
 
 You can then propose your branch for merging into trunk on the
@@ -119,7 +119,7 @@
 
 - C++ exceptions are allowed if they derive from std::exception. Most
   exception throwing is hidden behind log_fatal messages, which throw
-  scalestack::common::exception and contains custom messages. Use of
+  scalestack::kernel::exception and contains custom messages. Use of
   this through module.log_fatal() in modules is preferred.
 
 - All namespaces, classes, methods, and data members must be all

=== modified file 'configure.ac'
--- configure.ac	2011-01-25 06:25:30 +0000
+++ configure.ac	2011-01-25 20:51:51 +0000
@@ -62,7 +62,7 @@
 AC_DEFINE_UNQUOTED([SCALESTACK_MODULE_EXT], ["$acl_cv_shlibext"],
                    [Extension to use for modules.])
 
-AC_CONFIG_FILES(Makefile scalestack/common/macros.h docs/header.html)
+AC_CONFIG_FILES(Makefile scalestack/kernel/macros.h docs/header.html)
 
 AC_OUTPUT
 

=== removed directory 'scalestack/common'
=== removed file 'scalestack/common/notification.cc'
--- scalestack/common/notification.cc	2011-01-25 06:25:30 +0000
+++ scalestack/common/notification.cc	1970-01-01 00:00:00 +0000
@@ -1,82 +0,0 @@
-/*
- * Scale Stack
- *
- * Copyright 2010 Eric Day
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-/**
- * @file
- * @brief Notification Definitions
- */
-
-#include "config.h"
-
-#include <cerrno>
-#include <cstdio>
-#include <cstring>
-#include <unistd.h>
-
-#include <scalestack/common/exception.h>
-#include <scalestack/common/notification.h>
-
-namespace scalestack
-{
-namespace common
-{
-
-/*
- * Public methods.
- */
-
-notification::notification(void)
-{
-  if (pipe(_pipe) == -1)
-    _throw_exception(_("Could not create notification pipe"));
-}
-
-notification::~notification()
-{
-  close(_pipe[0]);
-  close(_pipe[1]);
-}
-
-void notification::send(void)
-{
-  if (write(_pipe[1], "\0", 1) == -1 && errno != EINTR)
-    _throw_exception(_("Could not write to notification pipe"));
-}
-
-void notification::wait(void)
-{
-  char buffer[1024];
-
-  if (read(_pipe[0], buffer, sizeof(buffer)) == -1 && errno != EINTR)
-    _throw_exception(_("Could not read from notification pipe"));
-}
-
-/*
- * Private methods.
- */
-
-void notification::_throw_exception(const char* prefix)
-{
-  char message[SCALESTACK_MAX_MESSAGE_SIZE];
-  snprintf(message, SCALESTACK_MAX_MESSAGE_SIZE,
-           "%s: %s:%d", prefix, strerror(errno), errno);
-  throw exception("notification", message);
-}
-
-} /* namespace common */
-} /* namespace scalestack */

=== removed file 'scalestack/common/notification.h'
--- scalestack/common/notification.h	2011-01-25 06:25:30 +0000
+++ scalestack/common/notification.h	1970-01-01 00:00:00 +0000
@@ -1,81 +0,0 @@
-/*
- * Scale Stack
- *
- * Copyright 2010 Eric Day
- *
- * Licensed under the Apache License, Version 2.0 (the "License");
- * you may not use this file except in compliance with the License.
- * You may obtain a copy of the License at
- *
- *     http://www.apache.org/licenses/LICENSE-2.0
- *
- * Unless required by applicable law or agreed to in writing, software
- * distributed under the License is distributed on an "AS IS" BASIS,
- * WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
- * See the License for the specific language governing permissions and
- * limitations under the License.
- */
-
-/**
- * @file
- * @brief Notification Declarations
- */
-
-#ifndef SCALESTACK_COMMON_NOTIFICATION_H
-#define SCALESTACK_COMMON_NOTIFICATION_H
-
-#include <scalestack/common/macros.h>
-
-namespace scalestack
-{
-namespace common
-{
-
-/**
- * This class provides a way for different threads to notify each other. This
- * uses a pipe rather than conditional thread mechanisms to be more portable.
- */
-class SCALESTACK_API notification
-{
-public:
-
-  notification(void);
-
-  ~notification();
-
-  /**
-   * Send a notification.
-   */
-  void send(void);
-
-  /**
-   * Wait for a notification.
-   */
-  void wait(void);
-
-private:
-
-  /**
-   * Don't allow copying of objects.
-   */
-  notification(const notification&);
-
-  /**
-   * Don't allow assignment of objects.
-   */
-  notification& operator=(const notification&);
-
-  /**
-   * Format an error message from errno and throw an exception.
-   *
-   * @param[in] prefix The prefix for the error message.
-   */
-  void _throw_exception(const char* prefix);
-
-  int _pipe[2];
-};
-
-} /* namespace common */
-} /* namespace scalestack */
-
-#endif /* SCALESTACK_COMMON_NOTIFICATION_H */

=== modified file 'scalestack/echo/flood/datagram.h'
--- scalestack/echo/flood/datagram.h	2011-01-25 06:25:30 +0000
+++ scalestack/echo/flood/datagram.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_ECHO_FLOOD_DATAGRAM_H
 #define SCALESTACK_ECHO_FLOOD_DATAGRAM_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/datagram.h>
 
 namespace scalestack

=== modified file 'scalestack/echo/flood/stream.h'
--- scalestack/echo/flood/stream.h	2011-01-25 06:25:30 +0000
+++ scalestack/echo/flood/stream.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_ECHO_FLOOD_STREAM_H
 #define SCALESTACK_ECHO_FLOOD_STREAM_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/stream.h>
 
 namespace scalestack

=== modified file 'scalestack/echo/server/datagram.h'
--- scalestack/echo/server/datagram.h	2011-01-25 06:25:30 +0000
+++ scalestack/echo/server/datagram.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_ECHO_SERVER_DATAGRAM_H
 #define SCALESTACK_ECHO_SERVER_DATAGRAM_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/datagram.h>
 
 namespace scalestack

=== modified file 'scalestack/echo/server/local_stream/test/run.cc'
--- scalestack/echo/server/local_stream/test/run.cc	2011-01-25 06:25:30 +0000
+++ scalestack/echo/server/local_stream/test/run.cc	2011-01-25 20:51:51 +0000
@@ -21,10 +21,12 @@
  * @brief Echo Server Unix Domain Socket Stream Test
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
 
 #include <unistd.h>
 
+#include <scalestack/kernel/test.h>
+
 static const char* test_socket = ".echoserver.local.stream.test";
 
 TEST_SUITE_BEGIN

=== modified file 'scalestack/echo/server/stream.h'
--- scalestack/echo/server/stream.h	2011-01-25 06:25:30 +0000
+++ scalestack/echo/server/stream.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_ECHO_SERVER_STREAM_H
 #define SCALESTACK_ECHO_SERVER_STREAM_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/stream.h>
 
 namespace scalestack

=== modified file 'scalestack/echo/server/tcp/test/run.cc'
--- scalestack/echo/server/tcp/test/run.cc	2011-01-25 06:25:30 +0000
+++ scalestack/echo/server/tcp/test/run.cc	2011-01-25 20:51:51 +0000
@@ -21,7 +21,9 @@
  * @brief Echo Server TCP Test
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
+
+#include <scalestack/kernel/test.h>
 
 static const char* test_address = ":32123";
 

=== modified file 'scalestack/echo/server/udp/test/run.cc'
--- scalestack/echo/server/udp/test/run.cc	2011-01-25 06:25:30 +0000
+++ scalestack/echo/server/udp/test/run.cc	2011-01-25 20:51:51 +0000
@@ -21,7 +21,9 @@
  * @brief Echo Server UDP Test
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
+
+#include <scalestack/kernel/test.h>
 
 static const char* test_addresses = "127.0.0.1:32123";
 

=== modified file 'scalestack/event/handler.h'
--- scalestack/event/handler.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/handler.h	2011-01-25 20:51:51 +0000
@@ -26,8 +26,8 @@
 
 #include <ctime>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/handler_service.h'
--- scalestack/event/handler_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/handler_service.h	2011-01-25 20:51:51 +0000
@@ -24,9 +24,9 @@
 #ifndef SCALESTACK_EVENT_HANDLER_SERVICE_H
 #define SCALESTACK_EVENT_HANDLER_SERVICE_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/service.h>
 #include <scalestack/kernel/core.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/kernel/module.h>
 #include <scalestack/kernel/service.h>
 

=== modified file 'scalestack/event/libevent/handler_provider.h'
--- scalestack/event/libevent/handler_provider.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/libevent/handler_provider.h	2011-01-25 20:51:51 +0000
@@ -26,8 +26,8 @@
 
 #include <event.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/libevent/handler_service_provider.cc'
--- scalestack/event/libevent/handler_service_provider.cc	2011-01-25 06:25:30 +0000
+++ scalestack/event/libevent/handler_service_provider.cc	2011-01-25 20:51:51 +0000
@@ -24,9 +24,11 @@
 #include "config.h"
 
 #include <algorithm>
+#include <cerrno>
 #include <cstring>
 #include <exception>
 #include <functional>
+#include <unistd.h>
 
 #include <scalestack/event/handler.h>
 #include <scalestack/event/libevent/handler_service_provider.h>
@@ -53,19 +55,28 @@
   _handler_count(),
   _service(static_cast<libevent::service&>(module.get_core().get_service("event"))),
   _handler_mutex(),
-  _shutdown_notification(),
+  _notification_pipe(),
   _handlers()
 {
   int return_code = pthread_mutex_init(&_handler_mutex, NULL);
   if (return_code != 0)
   {
     _module.log_fatal(_("Failed pthread_mutex_init: %s:%d"),
-                      strerror(return_code), return_code);
+      strerror(return_code), return_code);
+  }
+
+  if (pipe(_notification_pipe) == -1)
+  {
+    _module.log_fatal(_("Could not create notification pipe: %s:%d"),
+      strerror(errno), errno);
   }
 }
 
 handler_service_provider::~handler_service_provider()
 {
+  close(_notification_pipe[0]);
+  close(_notification_pipe[1]);
+
   int return_code = pthread_mutex_destroy(&_handler_mutex);
   if (return_code != 0)
   {
@@ -144,7 +155,13 @@
   --_handler_count;
 
   if (_shutdown)
-    _shutdown_notification.send();
+  {
+    if (write(_notification_pipe[1], "\0", 1) == -1 && errno != EINTR)
+    {
+      _module.log_fatal(_("Could not write to notification pipe: %s:%d"),
+        strerror(errno), errno);
+    }
+  }
 
   return_code = pthread_mutex_unlock(&_handler_mutex);
   if (return_code != 0)
@@ -167,6 +184,7 @@
 
   for_each(_handlers.begin(), _handlers.end(), mem_fun(&handler::remove));
 
+  char buffer[1024];
   while (_handler_count > 0)
   {
     return_code = pthread_mutex_unlock(&_handler_mutex);
@@ -176,7 +194,12 @@
                         strerror(return_code), return_code);
     }
 
-    _shutdown_notification.wait();
+    if (read(_notification_pipe[0], buffer, sizeof(buffer)) == -1 &&
+      errno != EINTR)
+    {
+      _module.log_fatal(_("Could not read from notification pipe: %s:%d"),
+        strerror(errno), errno);
+    }
 
     return_code = pthread_mutex_lock(&_handler_mutex);
     if (return_code != 0)

=== modified file 'scalestack/event/libevent/handler_service_provider.h'
--- scalestack/event/libevent/handler_service_provider.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/libevent/handler_service_provider.h	2011-01-25 20:51:51 +0000
@@ -27,8 +27,8 @@
 #include <pthread.h>
 #include <set>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {
@@ -86,7 +86,7 @@
   size_t _handler_count;
   libevent::service& _service;
   pthread_mutex_t _handler_mutex;
-  common::notification _shutdown_notification;
+  int _notification_pipe[2];
   handlers _handlers;
 };
 

=== modified file 'scalestack/event/libevent/service.h'
--- scalestack/event/libevent/service.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/libevent/service.h	2011-01-25 20:51:51 +0000
@@ -26,8 +26,8 @@
 
 #include <vector>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/libevent/thread.h'
--- scalestack/event/libevent/thread.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/libevent/thread.h	2011-01-25 20:51:51 +0000
@@ -29,7 +29,7 @@
 #include <stdint.h>
 #include <vector>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/service.h'
--- scalestack/event/service.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/service.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_EVENT_SERVICE_H
 #define SCALESTACK_EVENT_SERVICE_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/kernel/service.h>
 
 namespace scalestack

=== modified file 'scalestack/event/test/handler.h'
--- scalestack/event/test/handler.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/handler.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_EVENT_TEST_HANDLER_H
 #define SCALESTACK_EVENT_TEST_HANDLER_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/test/handler_provider.h'
--- scalestack/event/test/handler_provider.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/handler_provider.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_EVENT_TEST_HANDLER_PROVIDER_H
 #define SCALESTACK_EVENT_TEST_HANDLER_PROVIDER_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/test/handler_service.h'
--- scalestack/event/test/handler_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/handler_service.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_EVENT_TEST_HANDLER_SERVICE_H
 #define SCALESTACK_EVENT_TEST_HANDLER_SERVICE_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/test/handler_service_provider.h'
--- scalestack/event/test/handler_service_provider.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/handler_service_provider.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_EVENT_TEST_HANDLER_SERVICE_PROVIDER_H
 #define SCALESTACK_EVENT_TEST_HANDLER_SERVICE_PROVIDER_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/event/test/run.cc'
--- scalestack/event/test/run.cc	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/run.cc	2011-01-25 20:51:51 +0000
@@ -21,7 +21,9 @@
  * @brief Event Tests
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
+
+#include <scalestack/kernel/test.h>
 
 TEST_SUITE_BEGIN
 

=== modified file 'scalestack/event/test/service.h'
--- scalestack/event/test/service.h	2011-01-25 06:25:30 +0000
+++ scalestack/event/test/service.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_EVENT_TEST_SERVICE_H
 #define SCALESTACK_EVENT_TEST_SERVICE_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/kernel/core.cc'
--- scalestack/kernel/core.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/core.cc	2011-01-25 20:51:51 +0000
@@ -34,9 +34,9 @@
 #include <signal.h>
 #include <unistd.h>
 
-#include <scalestack/common/delete_pointer.h>
-#include <scalestack/common/exception.h>
 #include <scalestack/kernel/core.h>
+#include <scalestack/kernel/delete_pointer.h>
+#include <scalestack/kernel/exception.h>
 #include <scalestack/kernel/log_console.h>
 #include <scalestack/kernel/module.h>
 
@@ -74,7 +74,7 @@
   _need_config(false),
   _shutdown_request(false),
   _iterator_on_modules(false),
-  _run_notification(),
+  _notification_pipe(),
   _open_files(),
   _paths(),
   _modules(),
@@ -84,6 +84,12 @@
   _services(),
   _logs()
 {
+  if (pipe(_notification_pipe) == -1)
+  {
+    log_fatal(_("Could not create notification pipe: %s:%d"), strerror(errno),
+      errno);
+  }
+
   /* Add the default module path from configure. */
   _paths.push_back(SCALESTACK_QUOTE_VALUE(SCALESTACK_MODULE_PATH));
 
@@ -99,8 +105,8 @@
 
   for_each(_new_modules.begin(), _new_modules.end(), mem_fun(&module::_unload));
   for_each(_modules.begin(), _modules.end(), mem_fun(&module::_unload));
-  for_each(_new_modules.begin(), _new_modules.end(), common::delete_pointer());
-  for_each(_modules.begin(), _modules.end(), common::delete_pointer());
+  for_each(_new_modules.begin(), _new_modules.end(), delete_pointer());
+  for_each(_modules.begin(), _modules.end(), delete_pointer());
 
   if (get_service_count() != 0)
   {
@@ -125,6 +131,9 @@
 
   if (global_kernel_core == this)
     global_kernel_core = NULL;
+
+  close(_notification_pipe[0]);
+  close(_notification_pipe[1]);
 }
 
 void core::parse_arguments(int argument_count, const char** arguments)
@@ -491,12 +500,27 @@
 
   log_notice(_("Core now running"));
 
+  char buffer[1024];
   while (!_shutdown_request)
   {
     /* See if any modules need to be run or reconfigured. */
     for_each(_modules.begin(), _modules.end(), mem_fun(&module::_run));
     for_each(_modules.begin(), _modules.end(), mem_fun(&module::_reconfigure));
-    _run_notification.wait();
+    if (read(_notification_pipe[0], buffer, sizeof(buffer)) == -1 &&
+      errno != EINTR)
+    {
+      log_fatal(_("Could not read from notification pipe: %s:%d"),
+        strerror(errno), errno);
+    }
+  }
+}
+
+void core::notify(void)
+{
+  if (write(_notification_pipe[1], "\0", 1) == -1 && errno != EINTR)
+  {
+    log_fatal(_("Could not write to notification pipe: %s:%d"),
+      strerror(errno), errno);
   }
 }
 
@@ -504,7 +528,7 @@
 {
   log_notice(_("Core received shutdown request"));
   _shutdown_request = true;
-  _run_notification.send();
+  notify();
 }
 
 /*
@@ -619,7 +643,7 @@
 {
   char message[SCALESTACK_MAX_MESSAGE_SIZE];
   vsnprintf(message, SCALESTACK_MAX_MESSAGE_SIZE, format, arguments);
-  throw common::exception("kernel", message);
+  throw kernel::exception("kernel", message);
 }
 
 void core::_log_message(log::level log_level,
@@ -641,7 +665,7 @@
     log->second->write_log(log_level, context, message);
 
   if (log_level == log::LEVEL_FATAL)
-    throw common::exception(context, message);
+    throw kernel::exception(context, message);
 }
 
 void core::_print_help(void)

=== modified file 'scalestack/kernel/core.h'
--- scalestack/kernel/core.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/core.h	2011-01-25 20:51:51 +0000
@@ -28,9 +28,8 @@
 #include <string>
 #include <vector>
 
-#include <scalestack/common/macros.h>
-#include <scalestack/common/notification.h>
 #include <scalestack/kernel/logger.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {
@@ -232,6 +231,11 @@
   void run(void);
 
   /**
+   * Notify the main loop that it should wake up and process pending events.
+   */
+  void notify(void);
+
+  /**
    * Notify the kernel core that it should start the shutdown process. This is
    * usually called from signal handlers or modules providing administrative
    * functions.
@@ -339,7 +343,7 @@
   bool _need_config;
   bool _shutdown_request;
   bool _iterator_on_modules;
-  common::notification _run_notification;
+  int _notification_pipe[2];
   files _open_files;
   paths _paths;
   modules _modules;

=== renamed file 'scalestack/common/delete_pointer.h' => 'scalestack/kernel/delete_pointer.h'
--- scalestack/common/delete_pointer.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/delete_pointer.h	2011-01-25 20:51:51 +0000
@@ -21,14 +21,14 @@
  * @brief Delete Pointer Function Object
  */
 
-#ifndef SCALESTACK_COMMON_DELETE_POINTER_H
-#define SCALESTACK_COMMON_DELETE_POINTER_H
+#ifndef SCALESTACK_KERNEL_DELETE_POINTER_H
+#define SCALESTACK_KERNEL_DELETE_POINTER_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {
-namespace common
+namespace kernel
 {
 
 /**
@@ -49,7 +49,7 @@
   }
 };
 
-} /* namespace common */
+} /* namespace kernel */
 } /* namespace scalestack */
 
-#endif /* SCALESTACK_COMMON_DELETE_POINTER_H */
+#endif /* SCALESTACK_KERNEL_DELETE_POINTER_H */

=== renamed file 'scalestack/common/exception.cc' => 'scalestack/kernel/exception.cc'
--- scalestack/common/exception.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/exception.cc	2011-01-25 20:51:51 +0000
@@ -18,18 +18,18 @@
 
 /**
  * @file
- * @brief Common Exception Definitions
+ * @brief Kernel Exception Definitions
  */
 
 #include "config.h"
 
 #include <cstdio>
 
-#include <scalestack/common/exception.h>
+#include <scalestack/kernel/exception.h>
 
 namespace scalestack
 {
-namespace common
+namespace kernel
 {
 
 exception::exception(const char* context, const char* message) throw()
@@ -42,5 +42,5 @@
   return _message;
 }
 
-} /* namespace common */
+} /* namespace kernel */
 } /* namespace scalestack */

=== renamed file 'scalestack/common/exception.h' => 'scalestack/kernel/exception.h'
--- scalestack/common/exception.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/exception.h	2011-01-25 20:51:51 +0000
@@ -18,19 +18,19 @@
 
 /**
  * @file
- * @brief Common Exception Declarations
+ * @brief Kernel Exception Declarations
  */
 
-#ifndef SCALESTACK_COMMON_EXCEPTION_H
-#define SCALESTACK_COMMON_EXCEPTION_H
+#ifndef SCALESTACK_KERNEL_EXCEPTION_H
+#define SCALESTACK_KERNEL_EXCEPTION_H
 
 #include <exception>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {
-namespace common
+namespace kernel
 {
 
 /**
@@ -62,7 +62,7 @@
   char _message[SCALESTACK_MAX_MESSAGE_SIZE];
 };
 
-} /* namespace common */
+} /* namespace kernel */
 } /* namespace scalestack */
 
-#endif /* SCALESTACK_COMMON_EXCEPTION_H */
+#endif /* SCALESTACK_KERNEL_EXCEPTION_H */

=== modified file 'scalestack/kernel/log.h'
--- scalestack/kernel/log.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/log.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_KERNEL_LOG_H
 #define SCALESTACK_KERNEL_LOG_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/kernel/log_console.h'
--- scalestack/kernel/log_console.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/log_console.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_KERNEL_LOG_CONSOLE_H
 #define SCALESTACK_KERNEL_LOG_CONSOLE_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/kernel/log.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/kernel/logger.h'
--- scalestack/kernel/logger.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/logger.h	2011-01-25 20:51:51 +0000
@@ -26,7 +26,7 @@
 
 #include <cstdarg>
 
-#include <scalestack/common/exception.h>
+#include <scalestack/kernel/exception.h>
 #include <scalestack/kernel/log.h>
 
 namespace scalestack
@@ -160,7 +160,7 @@
     else
       _set_fatal_message(format, arguments);
   }
-  catch (common::exception&)
+  catch (kernel::exception&)
   {
     va_end(arguments);
     throw;

=== renamed file 'scalestack/common/macros.h.in' => 'scalestack/kernel/macros.h.in'
--- scalestack/common/macros.h.in	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/macros.h.in	2011-01-25 20:51:51 +0000
@@ -18,11 +18,11 @@
 
 /**
  * @file
- * @brief Common Macro Definitions
+ * @brief Kernel Macro Definitions
  */
 
-#ifndef SCALESTACK_COMMON_MACROS_H
-#define SCALESTACK_COMMON_MACROS_H
+#ifndef SCALESTACK_KERNEL_MACROS_H
+#define SCALESTACK_KERNEL_MACROS_H
 
 /**
  * Be sure to put SCALESTACK_API in front of all public API symbols, or one of
@@ -84,4 +84,4 @@
  */
 #define _(string) string
 
-#endif /* SCALESTACK_COMMON_MACROS_H */
+#endif /* SCALESTACK_KERNEL_MACROS_H */

=== modified file 'scalestack/kernel/module.cc'
--- scalestack/kernel/module.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/module.cc	2011-01-25 20:51:51 +0000
@@ -38,8 +38,8 @@
 #include <sys/types.h>
 #include <unistd.h>
 
-#include <scalestack/common/delete_pointer.h>
 #include <scalestack/kernel/core.h>
+#include <scalestack/kernel/delete_pointer.h>
 #include <scalestack/kernel/module.h>
 #include <scalestack/kernel/option.h>
 
@@ -60,7 +60,7 @@
 
   _unload();
 
-  for_each(_options.begin(), _options.end(), common::delete_pointer());
+  for_each(_options.begin(), _options.end(), delete_pointer());
 
   log_info(_("Destructed"));
 }
@@ -204,7 +204,7 @@
     return;
 
   _need_run = true;
-  _core._run_notification.send();
+  _core.notify();
 }
 
 string module::normalize_name(const std::string& name)
@@ -480,7 +480,7 @@
   if (_is_started)
   {
     _need_reconfigure = true;
-    _core._run_notification.send();
+    _core.notify();
   }
 }
 
@@ -498,7 +498,7 @@
 {
   char message[SCALESTACK_MAX_MESSAGE_SIZE];
   vsnprintf(message, SCALESTACK_MAX_MESSAGE_SIZE, format, arguments);
-  throw common::exception(_name.c_str(), message);
+  throw kernel::exception(_name.c_str(), message);
 }
 
 void module::_log_message(log::level log_level,

=== modified file 'scalestack/kernel/module.h'
--- scalestack/kernel/module.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/module.h	2011-01-25 20:51:51 +0000
@@ -28,8 +28,8 @@
 #include <string>
 #include <vector>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/kernel/logger.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/kernel/option.h'
--- scalestack/kernel/option.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/option.h	2011-01-25 20:51:51 +0000
@@ -28,7 +28,7 @@
 #include <utility>
 #include <vector>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/kernel/service.h'
--- scalestack/kernel/service.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/service.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_KERNEL_SERVICE_H
 #define SCALESTACK_KERNEL_SERVICE_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== renamed file 'scalestack/common/test.h' => 'scalestack/kernel/test.h'
--- scalestack/common/test.h	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/test.h	2011-01-25 20:51:51 +0000
@@ -18,13 +18,11 @@
 
 /**
  * @file
- * @brief Common Test Declarations and Macro Definitions
+ * @brief Kernel Test Declarations and Macro Definitions
  */
 
-#ifndef SCALESTACK_COMMON_TEST_H
-#define SCALESTACK_COMMON_TEST_H
-
-#include "config.h"
+#ifndef SCALESTACK_KERNEL_TEST_H
+#define SCALESTACK_KERNEL_TEST_H
 
 #include <cassert>
 #include <exception>
@@ -118,4 +116,4 @@
   TEST_EXCEPTION_END \
 while (false)
 
-#endif /* SCALESTACK_COMMON_TEST_H */
+#endif /* SCALESTACK_KERNEL_TEST_H */

=== modified file 'scalestack/kernel/test/core.cc'
--- scalestack/kernel/test/core.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/test/core.cc	2011-01-25 20:51:51 +0000
@@ -21,12 +21,13 @@
  * @brief Kernel Core Tests
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
 
 #include <cstdlib>
 #include <cstring>
 
 #include <scalestack/kernel/service.h>
+#include <scalestack/kernel/test.h>
 
 TEST_SUITE_BEGIN
 

=== modified file 'scalestack/kernel/test/module.cc'
--- scalestack/kernel/test/module.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/test/module.cc	2011-01-25 20:51:51 +0000
@@ -21,13 +21,14 @@
  * @brief Kernel Module Tests
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
 
 #include <signal.h>
 #include <sys/types.h>
 #include <unistd.h>
 
 #include <scalestack/kernel/module.h>
+#include <scalestack/kernel/test.h>
 
 TEST_SUITE_BEGIN
 

=== modified file 'scalestack/kernel/test/option.cc'
--- scalestack/kernel/test/option.cc	2011-01-25 06:25:30 +0000
+++ scalestack/kernel/test/option.cc	2011-01-25 20:51:51 +0000
@@ -21,10 +21,11 @@
  * @brief option Tests
  */
 
-#include <scalestack/common/test.h>
+#include "config.h"
 
 #include <scalestack/kernel/module.h>
 #include <scalestack/kernel/option.h>
+#include <scalestack/kernel/test.h>
 
 TEST_SUITE_BEGIN
 

=== modified file 'scalestack/network/datagram.h'
--- scalestack/network/datagram.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/datagram.h	2011-01-25 20:51:51 +0000
@@ -28,8 +28,8 @@
 #include <sys/socket.h>
 #include <sys/types.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/datagram_service.h>
 
 namespace scalestack

=== modified file 'scalestack/network/datagram_service.h'
--- scalestack/network/datagram_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/datagram_service.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_NETWORK_DATAGRAM_SERVICE_H
 #define SCALESTACK_NETWORK_DATAGRAM_SERVICE_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/kernel/service.h>
 
 namespace scalestack

=== modified file 'scalestack/network/ip/address_service.h'
--- scalestack/network/ip/address_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/address_service.h	2011-01-25 20:51:51 +0000
@@ -30,7 +30,7 @@
 #include <sys/types.h>
 #include <vector>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/network/ip/tcp/connection.h'
--- scalestack/network/ip/tcp/connection.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/tcp/connection.h	2011-01-25 20:51:51 +0000
@@ -26,7 +26,7 @@
 
 #include <string>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/stream.h>
 
 namespace scalestack

=== modified file 'scalestack/network/ip/tcp/connection_service.h'
--- scalestack/network/ip/tcp/connection_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/tcp/connection_service.h	2011-01-25 20:51:51 +0000
@@ -28,8 +28,8 @@
 #include <sys/socket.h>
 #include <sys/types.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/ip/address_service.h>
 
 namespace scalestack

=== modified file 'scalestack/network/ip/tcp/listener_service.h'
--- scalestack/network/ip/tcp/listener_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/tcp/listener_service.h	2011-01-25 20:51:51 +0000
@@ -26,7 +26,7 @@
 
 #include <string>
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/ip/address_service.h>
 #include <scalestack/network/listener_service.h>
 

=== modified file 'scalestack/network/ip/udp/socket.h'
--- scalestack/network/ip/udp/socket.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/udp/socket.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_NETWORK_IP_UDP_SOCKET_H
 #define SCALESTACK_NETWORK_IP_UDP_SOCKET_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/datagram.h>
 
 namespace scalestack

=== modified file 'scalestack/network/ip/udp/socket_service.h'
--- scalestack/network/ip/udp/socket_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/ip/udp/socket_service.h	2011-01-25 20:51:51 +0000
@@ -26,8 +26,8 @@
 
 #include <string>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/ip/address_service.h>
 
 namespace scalestack

=== modified file 'scalestack/network/listener.h'
--- scalestack/network/listener.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/listener.h	2011-01-25 20:51:51 +0000
@@ -24,8 +24,8 @@
 #ifndef SCALESTACK_NETWORK_LISTENER_H
 #define SCALESTACK_NETWORK_LISTENER_H
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 
 struct addrinfo;
 

=== modified file 'scalestack/network/listener_service.h'
--- scalestack/network/listener_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/listener_service.h	2011-01-25 20:51:51 +0000
@@ -27,8 +27,8 @@
 #include <sys/socket.h>
 #include <sys/types.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/network/local/common.h'
--- scalestack/network/local/common.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/local/common.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_NETWORK_LOCAL_COMMON_H
 #define SCALESTACK_NETWORK_LOCAL_COMMON_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/network/local/stream/connection.h'
--- scalestack/network/local/stream/connection.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/local/stream/connection.h	2011-01-25 20:51:51 +0000
@@ -30,8 +30,8 @@
 #include <sys/types.h>
 #include <sys/un.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/stream.h>
 
 namespace scalestack

=== modified file 'scalestack/network/local/stream/connection_service.h'
--- scalestack/network/local/stream/connection_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/local/stream/connection_service.h	2011-01-25 20:51:51 +0000
@@ -28,8 +28,8 @@
 #include <sys/socket.h>
 #include <sys/types.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler_service.h>
+#include <scalestack/kernel/macros.h>
 
 namespace scalestack
 {

=== modified file 'scalestack/network/stream.h'
--- scalestack/network/stream.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/stream.h	2011-01-25 20:51:51 +0000
@@ -26,8 +26,8 @@
 
 #include <stdint.h>
 
-#include <scalestack/common/macros.h>
 #include <scalestack/event/handler.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/network/stream_service.h>
 
 struct addrinfo;

=== modified file 'scalestack/network/stream_service.h'
--- scalestack/network/stream_service.h	2011-01-25 06:25:30 +0000
+++ scalestack/network/stream_service.h	2011-01-25 20:51:51 +0000
@@ -24,7 +24,7 @@
 #ifndef SCALESTACK_NETWORK_STREAM_SERVICE_H
 #define SCALESTACK_NETWORK_STREAM_SERVICE_H
 
-#include <scalestack/common/macros.h>
+#include <scalestack/kernel/macros.h>
 #include <scalestack/kernel/service.h>
 
 namespace scalestack

